/*
 * $Id$
 */

package org.apache.archiva.redback.rbac.jdo;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * 
 *         In RBAC terms, this is the entity which an operation is
 * associated with that which permissions are based on.
 *       
 * 
 * @version $Revision$ $Date$
 */
public class JdoResource 
implements org.apache.archiva.redback.rbac.Resource, java.io.Serializable
{


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field identifier
     */
    private String identifier;

    /**
     * Field pattern
     */
    private boolean pattern = false;

    /**
     * Field permanent
     */
    private boolean permanent = false;


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method equals
     * 
     * @param other
     */
    public boolean equals(Object other)
    {
        if ( this == other)
        {
            return true;
        }
        
        if ( !(other instanceof JdoResource) )
        {
            return false;
        }
        
        JdoResource that = (JdoResource) other;
        boolean result = true;
        result = result && ( getIdentifier() == null ? that.getIdentifier() == null : getIdentifier().equals( that.getIdentifier() ) );
        return result;
    } //-- boolean equals(Object) 

    /**
     * Get 
     *             The string identifier for a resource.
     *           
     */
    public String getIdentifier()
    {
        return this.identifier;
    } //-- String getIdentifier() 

    /**
     * Method hashCode
     */
    public int hashCode()
    {
        int result = 17;
        long tmp;
        result = 37 * result + ( identifier != null ? identifier.hashCode() : 0 );
        return result;
    } //-- int hashCode() 

    /**
     * Get 
     *             true if the identifer is a pattern that is to be
     * evaluated, for example x.* could match x.a or x.b and x.**
     *             could match x.foo
     *           
     */
    public boolean isPattern()
    {
        return this.pattern;
    } //-- boolean isPattern() 

    /**
     * Get 
     *             true if this object is permanent.
     *           
     */
    public boolean isPermanent()
    {
        return this.permanent;
    } //-- boolean isPermanent() 

    /**
     * Set 
     *             The string identifier for a resource.
     *           
     * 
     * @param identifier
     */
    public void setIdentifier(String identifier)
    {
        this.identifier = identifier;
    } //-- void setIdentifier(String) 

    /**
     * Set 
     *             true if the identifer is a pattern that is to be
     * evaluated, for example x.* could match x.a or x.b and x.**
     *             could match x.foo
     *           
     * 
     * @param pattern
     */
    public void setPattern(boolean pattern)
    {
        this.pattern = pattern;
    } //-- void setPattern(boolean) 

    /**
     * Set 
     *             true if this object is permanent.
     *           
     * 
     * @param permanent
     */
    public void setPermanent(boolean permanent)
    {
        this.permanent = permanent;
    } //-- void setPermanent(boolean) 

    /**
     * Method toString
     */
    public java.lang.String toString()
    {
        StringBuffer buf = new StringBuffer();
        buf.append( "identifier = '" );
        buf.append( getIdentifier() + "'" );
        return buf.toString();
    } //-- java.lang.String toString() 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
