/*
 * $Id$
 */

package org.apache.archiva.redback.rbac.jdo;

  //---------------------------------/
 //- Imported classes and packages -/
//---------------------------------/

import java.util.Date;

/**
 * null
 * 
 * @version $Revision$ $Date$
 */
public class JdoRole extends org.apache.archiva.redback.rbac.AbstractRole 
implements org.apache.archiva.redback.rbac.Role, java.io.Serializable
{


      //--------------------------/
     //- Class/Member Variables -/
    //--------------------------/

    /**
     * Field name
     */
    private String name;

    /**
     * Field description
     */
    private String description;

    /**
     * Field assignable
     */
    private boolean assignable = false;

    /**
     * Field permanent
     */
    private boolean permanent = false;

    /**
     * Field childRoleNames
     */
    private java.util.List childRoleNames = new java.util.ArrayList();

    /**
     * Field permissions
     */
    private java.util.List permissions = new java.util.ArrayList();


      //-----------/
     //- Methods -/
    //-----------/

    /**
     * Method addChildRoleName
     * 
     * @param string
     */
    public void addChildRoleName(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JdoRole.addChildRoleNames(string) parameter must be instanceof " + String.class.getName() );
        }
        getChildRoleNames().add( string );
    } //-- void addChildRoleName(String) 

    /**
     * Method addPermission
     * 
     * @param jdoPermission
     */
    public void addPermission(org.apache.archiva.redback.rbac.Permission jdoPermission)
    {
        if ( !(jdoPermission instanceof JdoPermission) )
        {
            throw new ClassCastException( "JdoRole.addPermissions(jdoPermission) parameter must be instanceof " + JdoPermission.class.getName() );
        }
        getPermissions().add( ( (JdoPermission) jdoPermission ) );
    } //-- void addPermission(org.apache.archiva.redback.rbac.Permission) 

    /**
     * Method equals
     * 
     * @param other
     */
    public boolean equals(Object other)
    {
        if ( this == other)
        {
            return true;
        }
        
        if ( !(other instanceof JdoRole) )
        {
            return false;
        }
        
        JdoRole that = (JdoRole) other;
        boolean result = true;
        result = result && ( getName() == null ? that.getName() == null : getName().equals( that.getName() ) );
        return result;
    } //-- boolean equals(Object) 

    /**
     * Method getChildRoleNames
     */
    public java.util.List getChildRoleNames()
    {
        return this.childRoleNames;
    } //-- java.util.List getChildRoleNames() 

    /**
     * Get null
     */
    public String getDescription()
    {
        return this.description;
    } //-- String getDescription() 

    /**
     * Get null
     */
    public String getName()
    {
        return this.name;
    } //-- String getName() 

    /**
     * Method getPermissions
     */
    public java.util.List getPermissions()
    {
        return this.permissions;
    } //-- java.util.List getPermissions() 

    /**
     * Method hashCode
     */
    public int hashCode()
    {
        int result = 17;
        long tmp;
        result = 37 * result + ( name != null ? name.hashCode() : 0 );
        return result;
    } //-- int hashCode() 

    /**
     * Get 
     *             true if this role is available to be assigned to
     * a user
     *           
     */
    public boolean isAssignable()
    {
        return this.assignable;
    } //-- boolean isAssignable() 

    /**
     * Get 
     *             true if this object is permanent.
     *           
     */
    public boolean isPermanent()
    {
        return this.permanent;
    } //-- boolean isPermanent() 

    /**
     * Method removeChildRoleName
     * 
     * @param string
     */
    public void removeChildRoleName(String string)
    {
        if ( !(string instanceof String) )
        {
            throw new ClassCastException( "JdoRole.removeChildRoleNames(string) parameter must be instanceof " + String.class.getName() );
        }
        getChildRoleNames().remove( string );
    } //-- void removeChildRoleName(String) 

    /**
     * Method removePermission
     * 
     * @param jdoPermission
     */
    public void removePermission(org.apache.archiva.redback.rbac.Permission jdoPermission)
    {
        if ( !(jdoPermission instanceof JdoPermission) )
        {
            throw new ClassCastException( "JdoRole.removePermissions(jdoPermission) parameter must be instanceof " + JdoPermission.class.getName() );
        }
        getPermissions().remove( ( (JdoPermission) jdoPermission ) );
    } //-- void removePermission(org.apache.archiva.redback.rbac.Permission) 

    /**
     * Set 
     *             true if this role is available to be assigned to
     * a user
     *           
     * 
     * @param assignable
     */
    public void setAssignable(boolean assignable)
    {
        this.assignable = assignable;
    } //-- void setAssignable(boolean) 

    /**
     * Set 
     *             roles that will inherit the permissions of this
     * role
     *           
     * 
     * @param childRoleNames
     */
    public void setChildRoleNames(java.util.List childRoleNames)
    {
        this.childRoleNames = childRoleNames;
    } //-- void setChildRoleNames(java.util.List) 

    /**
     * Set null
     * 
     * @param description
     */
    public void setDescription(String description)
    {
        this.description = description;
    } //-- void setDescription(String) 

    /**
     * Set null
     * 
     * @param name
     */
    public void setName(String name)
    {
        this.name = name;
    } //-- void setName(String) 

    /**
     * Set 
     *             true if this object is permanent.
     *           
     * 
     * @param permanent
     */
    public void setPermanent(boolean permanent)
    {
        this.permanent = permanent;
    } //-- void setPermanent(boolean) 

    /**
     * Set null
     * 
     * @param permissions
     */
    public void setPermissions(java.util.List permissions)
    {
        this.permissions = permissions;
    } //-- void setPermissions(java.util.List) 

    /**
     * Method toString
     */
    public java.lang.String toString()
    {
        StringBuffer buf = new StringBuffer();
        buf.append( "name = '" );
        buf.append( getName() + "'" );
        return buf.toString();
    } //-- java.lang.String toString() 


    private String modelEncoding = "UTF-8";

    public void setModelEncoding( String modelEncoding )
    {
        this.modelEncoding = modelEncoding;
    }

    public String getModelEncoding()
    {
        return modelEncoding;
    }
}
